/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
[ProgCnet - Boum!]
Auteur: Thaeron
Projet: "serveur" Boum! (bomberman) du concours ProgCnet
Licence: GPL

Copyright (C) 2007 Thaeron

This program is free software; you can redistribute it and/or 
modify it under the terms of the GNU General Public License as 
published by the Free Software Foundation; either version 2 of the 
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but 
WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
General Public License for more details.

You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software 
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 
USA
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

#include "boum.h"

int distance (int x, int y)
{
 int val;

 if (struct_map->init)
    return (PHASE_INIT);

 if (tab_players[struct_map->current_player]->status == MORT)
     return (JOUEUR_MORT);

 if (x >= struct_map->hauteur || y >= struct_map->longueur || x < 0 || y < 0)
 	return (ERREUR_COORD);
	
 if (tab_players[struct_map->current_player]->x == x && tab_players[struct_map->current_player]->y == y)
	return (0); /* dj sur la case donc distance = 0 */

 val = struct_map->map[x][y];
 if (val == RIEN || val == FLAMME_BONUS || val == MOTION_BONUS || val == BOMBE_BONUS)
	return (boum_distance_back (tab_players[struct_map->current_player]->x, tab_players[struct_map->current_player]->y, x, y));

 return (ERREUR_TERRAIN);
}

int aller_xy (int x, int y)
{
 int val;
/* printf ("%d %d\n", x, y);*/
 
 if (struct_map->init)
  	return (PHASE_INIT);

 if (tab_players[struct_map->current_player]->status == MORT)
     return (JOUEUR_MORT);
 
 if (!tab_players[struct_map->current_player]->mvt_dispo)
	return (PLUS_DE_MOUVEMENT);
 
 if (x >= struct_map->hauteur || y >= struct_map->longueur || x < 0 || y < 0)
 	return (ERREUR_COORD);
 
 if (tab_players[struct_map->current_player]->x == x && tab_players[struct_map->current_player]->y == y)
	return (MOUVEMENT_IMPOSSIBLE); /* t'es dj sur la case connard ! */
      
 val = struct_map->map[x][y];
 if (val == RIEN || val == FLAMME_BONUS || val == MOTION_BONUS || val == BOMBE_BONUS)
	return (boum_pathfinding (x, y));

  return (ERREUR_TERRAIN);
}

int
aller_gauche (void)
{
  return (back_aller
	  (tab_players[struct_map->current_player]->x,
	   tab_players[struct_map->current_player]->y - 1));
}

int
aller_droite (void)
{
  return (back_aller
	  (tab_players[struct_map->current_player]->x,
	   tab_players[struct_map->current_player]->y + 1));
}

int
aller_haut (void)
{
  return (back_aller
	  (tab_players[struct_map->current_player]->x - 1,
	   tab_players[struct_map->current_player]->y));
}

int
aller_bas (void)
{
  return (back_aller
	  (tab_players[struct_map->current_player]->x + 1,
	   tab_players[struct_map->current_player]->y));
}

int
nb_bombes_total (int id)
{
  if (id >= struct_map->nb_joueur_tot || id < 0)
    return (PAS_DE_JOUEUR);

  if (tab_players[id]->status == MORT)
    return (JOUEUR_MORT);

  return (tab_players[id]->bombe_tot);
}

int
nb_bombes_dispo (int id)
{
  if (id >= struct_map->nb_joueur_tot || id < 0)
    return (PAS_DE_JOUEUR);

  if (tab_players[id]->status == MORT)
    return (JOUEUR_MORT);

  return (tab_players[id]->bombe_dispo);
}

int
mon_nb_bombes_total (void)
{
  if (tab_players[struct_map->current_player]->status == MORT)
     return (JOUEUR_MORT);
     
  return (tab_players[struct_map->current_player]->bombe_tot);
}

int
mon_nb_bombes_dispo (void)
{
  if (tab_players[struct_map->current_player]->status == MORT)
     return (JOUEUR_MORT);
     
  return (tab_players[struct_map->current_player]->bombe_dispo);
}

int
poser_bombe (void)
{
  if (struct_map->init)
  	return (PHASE_INIT);

  if (tab_players[struct_map->current_player]->status == MORT)
     return (JOUEUR_MORT);
     
  if (!tab_players[struct_map->current_player]->bombe_dispo)
    return (PAS_DE_BOMBE);
    
  if (struct_map->map[tab_players[struct_map->current_player]->x][tab_players[struct_map->current_player]->y] >= BOMBE_JOUEUR)
    return (DEJA_UNE_BOMBE);

  struct_map->map[tab_players[struct_map->current_player]->x][tab_players[struct_map->current_player]->y] = BOMBE_JOUEUR + struct_map->current_player;
  ajouter_bombe ();
  tab_players[struct_map->current_player]->bombe_dispo--;

  return (NP);
}

int
position_joueur (int id, int *x, int *y)
{
  if (id >= struct_map->nb_joueur_tot || id < 0)
    return (PAS_DE_JOUEUR);

  if (tab_players[id]->status == MORT)
    return (JOUEUR_MORT);

  *x = tab_players[id]->x;
  *y = tab_players[id]->y;

  return (NP);
}

int
position_x_joueur (int id)
{
  if (id >= struct_map->nb_joueur_tot || id < 0)
    return (PAS_DE_JOUEUR);

  if (tab_players[id]->status == MORT)
    return (JOUEUR_MORT);

  return (tab_players[id]->x);
}

int
position_y_joueur (int id)
{
  if (id >= struct_map->nb_joueur_tot || id < 0)
    return (PAS_DE_JOUEUR);

  if (tab_players[id]->status == MORT)
    return (JOUEUR_MORT);

  return (tab_players[id]->y);
}

int
mon_id (void)
{
  if (tab_players[struct_map->current_player]->status == MORT)
     return (JOUEUR_MORT);
     
  return (struct_map->current_player);
}

int
ma_position (int *x, int *y)
{
  if (tab_players[struct_map->current_player]->status == MORT)
     return (JOUEUR_MORT);
     
  *x = tab_players[struct_map->current_player]->x;
  *y = tab_players[struct_map->current_player]->y;

  return (NP);
}

int
ma_position_x (void)
{
  if (tab_players[struct_map->current_player]->status == MORT)
     return (JOUEUR_MORT);
     
  return (tab_players[struct_map->current_player]->x);
}

int
ma_position_y (void)
{
  if (tab_players[struct_map->current_player]->status == MORT)
     return (JOUEUR_MORT);
     
  return (tab_players[struct_map->current_player]->y);
}

int
nb_total_joueurs (void)
{
  return (struct_map->nb_joueur_tot);
}

int
nb_joueurs_lice (void)
{
  return (struct_map->nb_joueur_lice);
}

int
nb_total_tours (void)
{
  return (struct_map->tour);
}

int
tour_en_cours (void)
{
  return (struct_map->date);
}

int
nb_bombe_bonus (void)
{
  return (struct_map->nb_bombe_bonus);
}

int
nb_flamme_bonus (void)
{
  return (struct_map->nb_flamme_bonus);
}

int
nb_motion_bonus (void)
{
  return (struct_map->nb_motion_bonus);
}

int
ma_puissance (void)
{
  if (tab_players[struct_map->current_player]->status == MORT)
     return (JOUEUR_MORT);
     
  return (tab_players[struct_map->current_player]->puissance);
}

int
puissance_joueur (int id)
{
  if (id >= struct_map->nb_joueur_tot || id < 0)
    return (PAS_DE_JOUEUR);

  if (tab_players[id]->status == MORT)
    return (JOUEUR_MORT);

  return (tab_players[id]->puissance);
}

int
temps_restant_bombe (int x, int y)
{
  int i;
  for (i = 0; i < struct_map->nb_bombe; i++)
    if (x == tab_bombe[i]->x && y == tab_bombe[i]->y)
      return (tab_bombe[i]->tours);

  return (PAS_DE_BOMBE);
}

int
puissance_bombe (int x, int y)
{
  int i;
  for (i = 0; i < struct_map->nb_bombe; i++)
    if (x == tab_bombe[i]->x && y == tab_bombe[i]->y)
      return (tab_bombe[i]->puissance);

  return (PAS_DE_BOMBE);
}

int
joueur_bombe (int x, int y)
{
  int i;
  for (i = 0; i < struct_map->nb_bombe; i++)
    if (x == tab_bombe[i]->x && y == tab_bombe[i]->y)
      return (tab_bombe[i]->player->num);

  return (PAS_DE_BOMBE);
}

int
largeur_map (void)
{
  return (struct_map->longueur);
}

int
hauteur_map (void)
{
  return (struct_map->hauteur);
}

int
status_joueur (int id)
{
  if (id >= struct_map->nb_joueur_tot || id < 0)
    return (PAS_DE_JOUEUR);

  if (tab_players[id]->status == MORT)
    return (JOUEUR_MORT);

  return (JOUEUR_VIVANT);
}

int
ya_quoi (int x, int y)
{
 if (x >= struct_map->hauteur || y >= struct_map->longueur || x < 0 || y < 0)
 	return (ERREUR_COORD);
  return (struct_map->map[x][y]);
}

int mvt_total (void)
{
  if (tab_players[struct_map->current_player]->status == MORT)
     return (JOUEUR_MORT);

  return (tab_players[struct_map->current_player]->mvt_tot);
}

int mvt_dispo (void)
{
  if (tab_players[struct_map->current_player]->status == MORT)
     return (JOUEUR_MORT);

  return (tab_players[struct_map->current_player]->mvt_dispo);
}

#ifdef WIN32
void init_apis_win32 (void)
{
 share_ptr_f._ya_quoi = ya_quoi;
 share_ptr_f._aller_xy = aller_xy;
 share_ptr_f._distance = distance;
 share_ptr_f._puissance_bombe = puissance_bombe;
 share_ptr_f._temps_restant_bombe = temps_restant_bombe;
 share_ptr_f._joueur_bombe = joueur_bombe;
 share_ptr_f._aller_gauche = aller_gauche;
 share_ptr_f._aller_droite = aller_droite;
 share_ptr_f._aller_haut = aller_haut;
 share_ptr_f._aller_bas = aller_bas;
 share_ptr_f._nb_bombes_total = nb_bombes_total;
 share_ptr_f._nb_bombes_dispo = nb_bombes_dispo;
 share_ptr_f._mon_nb_bombes_total = mon_nb_bombes_total;
 share_ptr_f._mon_nb_bombes_dispo = mon_nb_bombes_dispo;
 share_ptr_f._poser_bombe = poser_bombe;
 share_ptr_f._mon_id = mon_id;
 share_ptr_f._nb_total_joueurs = nb_total_joueurs;
 share_ptr_f._nb_joueurs_lice = nb_joueurs_lice;
 share_ptr_f._nb_total_tours = nb_total_tours;
 share_ptr_f._tour_en_cours = tour_en_cours;
 share_ptr_f._nb_bombe_bonus = nb_bombe_bonus;
 share_ptr_f._nb_flamme_bonus = nb_flamme_bonus;
 share_ptr_f._nb_motion_bonus = nb_motion_bonus;
 share_ptr_f._ma_position_x = ma_position_x;
 share_ptr_f._ma_position_y = ma_position_y;
 share_ptr_f._ma_puissance = ma_puissance;
 share_ptr_f._largeur_map = largeur_map;
 share_ptr_f._hauteur_map = hauteur_map;
 share_ptr_f._mvt_total = mvt_total;
 share_ptr_f._mvt_dispo = mvt_dispo;
 share_ptr_f._position_x_joueur = position_x_joueur;
 share_ptr_f._position_y_joueur = position_y_joueur;
 share_ptr_f._puissance_joueur = puissance_joueur;
 share_ptr_f._status_joueur = status_joueur;
 share_ptr_f._position_joueur = position_joueur;
 share_ptr_f._ma_position = ma_position;
} 
#endif
