/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
[ProgCnet - Boum!]
Auteur: Thaeron
Projet: "serveur" Boum! (bomberman) du concours ProgCnet
Licence: GPL

Copyright (C) 2007 Thaeron

This program is free software; you can redistribute it and/or 
modify it under the terms of the GNU General Public License as 
published by the Free Software Foundation; either version 2 of the 
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but 
WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
General Public License for more details.

You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software 
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 
USA
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

enum
{ JOUEUR = 0, RIEN =
    100, MUR, BRIQUE, BRIQUE_FRAGILE, MOTION_BONUS, BOMBE_BONUS, FLAMME_BONUS, BONUS_FRAGILE, FLAMME, BOMBE,
  BOMBE_JOUEUR
};

enum
{ PAS_DE_JOUEUR = -11, PHASE_INIT, JOUEUR_MORT, JOUEUR_VIVANT, PLUS_DE_MOUVEMENT, PAS_DE_CHEMIN, ERREUR_TERRAIN, 
ERREUR_COORD, MOUVEMENT_IMPOSSIBLE, PAS_DE_BOMBE, DEJA_UNE_BOMBE, NP };

#ifndef WIN32
int ya_quoi (int x, int y);

int aller_gauche (void);
int aller_droite (void);
int aller_haut (void);
int aller_bas (void);
int aller_xy (int x, int y);
int distance (int x, int y);

int nb_bombes_total (int id);
int nb_bombes_dispo (int id);
int mon_nb_bombes_total (void);
int mon_nb_bombes_dispo (void);
int poser_bombe (void);

int position_joueur (int id, int *x, int *y);
int position_x_joueur (int id);
int position_y_joueur (int id);
int ma_position (int *x, int *y);
int ma_position_x (void);
int ma_position_y (void);

int mon_id (void);


int nb_total_joueurs (void);
int nb_joueurs_lice (void);

int nb_total_tours (void);
int tour_en_cours (void);

int nb_bombe_bonus (void);
int nb_flamme_bonus (void);
int nb_motion_bonus (void);

int ma_puissance (void);
int puissance_joueur (int id);
int puissance_bombe (int x, int y);

int temps_restant_bombe (int x, int y);
int joueur_bombe (int x, int y);

int largeur_map (void);
int hauteur_map (void);

int status_joueur (int id);

int mvt_total (void);
int mvt_dispo (void);

#else
#define ya_quoi 		ptr_fonctions->_ya_quoi
#define aller_xy 		ptr_fonctions->_aller_xy
#define distance 		ptr_fonctions->_distance
#define puissance_bombe 	ptr_fonctions->_puissance_bombe
#define temps_restant_bombe 	ptr_fonctions->_temps_restant_bombe
#define joueur_bombe 		ptr_fonctions->_joueur_bombe
#define aller_gauche 		ptr_fonctions->_aller_gauche
#define aller_droite 		ptr_fonctions->_aller_droite
#define aller_haut 		ptr_fonctions->_aller_haut
#define aller_bas 		ptr_fonctions->_aller_bas
#define nb_bombes_total 	ptr_fonctions->_nb_bombes_total
#define nb_bombes_dispo 	ptr_fonctions->_nb_bombes_dispo
#define mon_nb_bombes_total 	ptr_fonctions->_mon_nb_bombes_total
#define mon_nb_bombes_dispo 	ptr_fonctions->_mon_nb_bombes_dispo
#define poser_bombe 		ptr_fonctions->_poser_bombe
#define mon_id 			ptr_fonctions->_mon_id
#define nb_total_joueurs 	ptr_fonctions->_nb_total_joueurs
#define nb_joueurs_lice 	ptr_fonctions->_nb_joueurs_lice
#define nb_total_tours 		ptr_fonctions->_nb_total_tours
#define tour_en_cours 		ptr_fonctions->_tour_en_cours
#define nb_bombe_bonus 		ptr_fonctions->_nb_bombe_bonus
#define nb_flamme_bonus 	ptr_fonctions->_nb_flamme_bonus
#define nb_motion_bonus 	ptr_fonctions->_nb_motion_bonus
#define ma_position_x 		ptr_fonctions->_ma_position_x
#define ma_position_y 		ptr_fonctions->_ma_position_y
#define ma_puissance 		ptr_fonctions->_ma_puissance
#define largeur_map 		ptr_fonctions->_largeur_map
#define hauteur_map 		ptr_fonctions->_hauteur_map
#define mvt_total 		ptr_fonctions->_mvt_total
#define mvt_dispo 		ptr_fonctions->_mvt_dispo
#define position_x_joueur 	ptr_fonctions->_position_x_joueur
#define position_y_joueur 	ptr_fonctions->_position_y_joueur
#define puissance_joueur 	ptr_fonctions->_puissance_joueur
#define status_joueur 		ptr_fonctions->_status_joueur
#define position_joueur 	ptr_fonctions->_position_joueur
#define ma_position 		ptr_fonctions->_ma_position

typedef int (*int_fct_2_int) (int, int);
typedef int (*int_fct_void) (void);
typedef int (*int_fct_int) (int);
typedef int (*int_fct_int_2_ptr) (int, int *, int *);
typedef int (*int_fct_2_ptr) (int *, int *);

typedef struct _ptr_fcts_t ptr_fcts_t;
struct _ptr_fcts_t
{
 int_fct_2_int _ya_quoi;
 int_fct_2_int _aller_xy;
 int_fct_2_int _distance;
 int_fct_2_int _puissance_bombe;
 int_fct_2_int _temps_restant_bombe;
 int_fct_2_int _joueur_bombe;
 int_fct_void _aller_gauche;
 int_fct_void _aller_droite;
 int_fct_void _aller_haut;
 int_fct_void _aller_bas;
 int_fct_void _mon_nb_bombes_total;
 int_fct_void _mon_nb_bombes_dispo;
 int_fct_void _poser_bombe;
 int_fct_void _mon_id;
 int_fct_void _nb_total_joueurs;
 int_fct_void _nb_joueurs_lice;
 int_fct_void _nb_total_tours;
 int_fct_void _tour_en_cours;
 int_fct_void _nb_bombe_bonus;
 int_fct_void _nb_flamme_bonus;
 int_fct_void _nb_motion_bonus;
 int_fct_void _ma_position_x;
 int_fct_void _ma_position_y;
 int_fct_void _ma_puissance;
 int_fct_void _largeur_map;
 int_fct_void _hauteur_map;
 int_fct_void _mvt_total;
 int_fct_void _mvt_dispo;
 int_fct_int _position_x_joueur;
 int_fct_int _position_y_joueur;
 int_fct_int _puissance_joueur;
 int_fct_int _nb_bombes_total;
 int_fct_int _nb_bombes_dispo;
 int_fct_int _status_joueur;
 int_fct_int_2_ptr _position_joueur;
 int_fct_2_ptr _ma_position;
};
ptr_fcts_t *ptr_fonctions;

#endif

