/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
[ProgCnet - Boum!]
Auteur: Thaeron
Projet: "serveur" Boum! (bomberman) du concours ProgCnet
Version: 0.3
Licence: GPL

Copyright (C) 2007 Thaeron

This program is free software; you can redistribute it and/or 
modify it under the terms of the GNU General Public License as 
published by the Free Software Foundation; either version 2 of the 
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but 
WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
General Public License for more details.

You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software 
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 
USA
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

#include "boum.h"

#if defined (ENABLE_SEGFAULT) || defined (ENABLE_FROZEN)
void signal_handler (int sigid)
{
  if (ia_is_crashed)
  {
  	fprintf (stderr, "Abort : tout est crash !\n");
	exit (0);
  }
  
  if (sigid == SIGSEGV || sigid == SIGILL || sigid == SIGFPE)
	  fprintf (stderr, "Segfault : %d,%d\n", struct_map->current_player, struct_map->date);

  else
 	  fprintf (stderr, "Frozen : %d,%d\n", struct_map->current_player, struct_map->date);
  
  ia_is_crashed = 1;
  siglongjmp (envx, 1);
}
#endif

int
fonction_principoile (void)
{
  int i, flag_b, flag_c = 0;
  ia_is_crashed = 0;
 #ifdef ENABLE_TIMEOUT
  clock_t t1, t2;
 #endif
  
  for (struct_map->date = 0; struct_map->date < struct_map->tour; struct_map->date++)
    {

      for (struct_map->current_player = 0; struct_map->current_player < struct_map->nb_joueur_tot; struct_map->current_player++)
	{
	  if (tab_players[struct_map->current_player]->status == VIVANT)
	  {
	      tab_players[struct_map->current_player]->mvt_dispo = tab_players[struct_map->current_player]->mvt_tot;
	     #if defined (ENABLE_SEGFAULT) || defined (ENABLE_FROZEN)
	      sigsetjmp (envx, 1);
	     #endif
	      if (ia_is_crashed)
	      {
		  ia_is_crashed = 0;
		#ifdef ENABLE_FROZEN
		  alarm (0);
		#endif
		  player_expulse (struct_map->current_player);
	      }
	      else 
	      {
		#ifdef ENABLE_FROZEN
		  alarm (1);
		#endif
		#ifdef ENABLE_TIMEOUT
		  t1 = clock();
		#endif
	          tab_players[struct_map->current_player]->fct_turn ();
		#ifdef ENABLE_TIMEOUT
		  t2 = clock();
		#endif
		#ifdef ENABLE_FROZEN
	      	  alarm (0);
		#endif
		#ifdef ENABLE_TIMEOUT
		  if ((t2 - t1) > LIMITE_TEMPS)
		  {
   		       player_expulse (struct_map->current_player);
		       fprintf (stderr, "Timeout : %d,%d\n", struct_map->current_player, struct_map->date);
		  }
		 #endif

	      }
	      if (enable_gui)
		     gui_m->gui_turn ();
		
	     /* print_map (struct_map->map, struct_map->hauteur, struct_map->longueur);*/
	  }
	}
      virer_explosion ();

      for (i = 0; i < struct_map->nb_bombe; i++)
	tab_bombe[i]->tours--;

      flag_c = 0;
      do
	{
	  flag_b = 0;
	  for (i = 0; i < struct_map->nb_bombe; i++)
	    if (!tab_bombe[i]->tours && !tab_bombe[i]->a_explose)
	      {
		/*printf ("la bombe %d a explos\n", i);*/
		ajouter_explosion (i);
		/*puts ("-------------------------");*/
		flag_b = 1;
		flag_c = 1;
	      }
	}
      while (flag_b);

      if (flag_c)
	{
	  clean_map ();
	  clean_bombe_tab ();
	}

     if (!struct_map->nb_joueur_lice)
     {
     	fprintf (stderr, "Draw : %d\n", struct_map->date);	      
	if (enable_gui)
	    	gui_m->gui_turn ();
	return (-1);
     }
     else 
     	if (struct_map->nb_joueur_lice == 1)
		for (i = 0; i < struct_map->nb_joueur_tot; i++)
			if (tab_players[i]->status == VIVANT)
			{
			        fprintf (stderr, "Victoire : %d\n", i);
				if (enable_gui)
	    				gui_m->gui_turn ();
				return (i);
			}

    }
 fprintf (stderr, "Draw : %d\n", struct_map->date);
 return (-2);
}

int
main (int argc, char *argv[])
{
  int map_id;
    
  srand (time (NULL));
  tab_players = NULL;
  tab_bombe = NULL;
  gui_m = NULL;

 #ifdef ENABLE_FROZEN
  signal (SIGALRM, signal_handler);
 #endif
 #ifdef ENABLE_SEGFAULT
  signal (SIGSEGV, signal_handler);
  signal (SIGFPE, signal_handler);
  signal (SIGILL, signal_handler);
 #endif
 #ifdef WIN32
 	init_apis_win32();
 #endif
 
  if (argc < 5)
    {
      fprintf (stderr, "Erreur : usage : ./%s --gui map nb_tours ./ia1.so ./ia2.so ...\n",
	      argv[0]);
      return (0);
    }


/* chargement du module de la GUI si elle est demande */
  if (!strcmp (argv[1], "--gui"))
    {
      enable_gui = 1;
      map_id = 2;
      gui_m = load_gui (GUI_FILENAME);
      if (!gui_m)
	{
	  fprintf (stderr, "Erreur : impossible de charger la GUI %s\n", GUI_FILENAME);
	  return (0);
	}
    }
  else
    {
      map_id = 1;
      enable_gui = 0;
    }

  NB_TOUR = atoi (argv[map_id + 1]);

/* chargement de la MAP */
  struct_map = load_map (argv[map_id]);
  if (!struct_map)
    {
      fprintf (stderr, "Erreur : la map %s est introuvable\n", argv[map_id]);
      return (0);
    }
 
/* chargement des modules des IAs */
  tab_players = load_ia (argv + map_id + 2, argc - (map_id + 2), struct_map);
  if (!tab_players)
    {
      fprintf (stderr, "Erreur : a s'est mal pass\n");
      free_map_pos (struct_map);
      free_map (struct_map);
      free_gui (gui_m);
      return (0);
    }
  free_map_pos (struct_map);


/* appel de la fonction init de chaque IA */
  struct_map->init = 1;

  for (struct_map->current_player = 0; struct_map->current_player < struct_map->nb_joueur_tot; struct_map->current_player++)
  {
  #ifdef WIN32
    tab_players[struct_map->current_player]->init_ptr_fonctions (&share_ptr_f);
  #endif
    tab_players[struct_map->current_player]->init_ia ();
  }
  
  struct_map->init = 0;
    
  if (enable_gui)
  {
  #ifdef WIN32
    gui_m->init_ptr_fonctions (&share_ptr_f);
  #endif
    gui_m->gui_init ();
    gui_m->gui_turn ();
  }

  
/* allez c'est parti pour le jeu */
  fonction_principoile ();


/* nettoyage  sec de tout le bordel */
  free_ia (tab_players, argc - (map_id + 2));
  free_bombe (tab_bombe, struct_map->nb_bombe);
  free_map (struct_map);
  free_gui (gui_m);
  return (0);
}
