/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
[ProgCnet - Boum!]
Auteur: Thaeron
Projet: "serveur" Boum! (bomberman) du concours ProgCnet
Licence: GPL

Copyright (C) 2007 Thaeron

This program is free software; you can redistribute it and/or 
modify it under the terms of the GNU General Public License as 
published by the Free Software Foundation; either version 2 of the 
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but 
WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
General Public License for more details.

You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software 
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 
USA
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

#include "boum.h"


gui_module_t *
load_gui (char *filename)
{
  gui_module_t *popo;
  popo = (gui_module_t *) malloc (sizeof (gui_module_t));
  popo->hd = dlopen (filename, RTLD_NOW);
  if (!popo->hd)
    return (NULL);

  popo->gui_turn = (void *) dlsym (popo->hd, "tour_gui");
  if (!popo->gui_turn)
    {
      dlclose (popo->hd);
      printf ("Erreur : il manque la fonction tour_gui dans la GUI\n");
      return (NULL);
    }

  popo->gui_init = (void *) dlsym (popo->hd, "init_gui");
  if (!popo->gui_init)
    {
      dlclose (popo->hd);
      printf ("Erreur : il manque la fonction tour_gui dans la GUI\n");
      return (NULL);
    }

  popo->gui_quit = (void *) dlsym (popo->hd, "quit_gui");
  if (!popo->gui_quit)
    {
      dlclose (popo->hd);
      printf ("Erreur : il manque la fonction quit_gui dans la GUI\n");
      return (NULL);
    }
#ifdef WIN32
  popo->init_ptr_fonctions = (void *) dlsym (popo->hd, "init_ptr_fonctions");
  if (!popo->init_ptr_fonctions)
    {
      dlclose (popo->hd);
      printf ("Erreur : il manque la fonction init_ptr_fonctions dans la GUI\n");
      return (NULL);
    }
#endif

  return (popo);
}


void
free_gui (gui_module_t * ptr)
{
  if (!ptr)
  	return;
  ptr->gui_quit();	
  dlclose (ptr->hd);
  free (ptr);
}
