/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
[ProgCnet - Boum!]
Auteur: Thaeron
Projet: "serveur" Boum! (bomberman) du concours ProgCnet
Version: 0.2
Licence: GPL

Copyright (C) 2007 Thaeron

This program is free software; you can redistribute it and/or 
modify it under the terms of the GNU General Public License as 
published by the Free Software Foundation; either version 2 of the 
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but 
WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
General Public License for more details.

You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software 
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 
USA
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

#include <stdlib.h>
#include <stdio.h>
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include <unistd.h>
#include "../boum-ia.h"

#ifndef WIN32
#define sleep_ms(x) usleep(x*1000)
#else
#include <windows.h>
#define sleep_ms(x) Sleep(x)
#endif

#define NB_ELEMENTS 12
#define TAILLE_ELEMENT 33
#define NB_PLAYERS 6

int longueur, hauteur;
int marre = 0, mode_boucle = 0;
int nb_tour;
SDL_Surface *ecran = NULL;
SDL_Surface *elements[NB_ELEMENTS];

SDL_Surface *players[NB_PLAYERS];
SDL_Surface *bomb_players[NB_PLAYERS];

void
pwet (void)
{
  int continuer = 1, g = 0;
  SDL_Event event;

  if (mode_boucle)
  	for (g = 0; g < 7; g++)
    	{
    		SDL_PollEvent (&event);
    		if (event.type == SDL_QUIT)
    		marre = 1;
		else if (event.type == SDL_KEYDOWN && event.key.keysym.sym == SDLK_RETURN)
		{
			mode_boucle = 0;
			break;
		}
       		sleep_ms (10);
    	}

  while (continuer && !mode_boucle)
    {
        SDL_WaitEvent (&event);
        switch (event.type)
	{
	case SDL_QUIT:
	  marre = 1;
	  continuer = 0;
	  break;

	case SDL_KEYDOWN:
	 if (event.key.keysym.sym == SDLK_SPACE)
	    continuer = 0;
	 if (event.key.keysym.sym == SDLK_RETURN)
	     mode_boucle = 1;
	  break;

	default:
	  break;
	}
    }
}


void
quit_gui (void)
{
  SDL_Quit ();
}

void
tour_gui (void)
{
  int i, j;
  SDL_Rect pos;
  int ret;
  char buffer[30];

  if (!marre)
    {
      SDL_FillRect (ecran, NULL, SDL_MapRGB (ecran->format, 0, 0, 0));

      for (i = 0; i < hauteur; i++)
	for (j = 0; j < longueur; j++)
	  {
	    pos.y = i * TAILLE_ELEMENT;
	    pos.x = j * TAILLE_ELEMENT;
	    ret = ya_quoi (i, j);
	    if (ret >= RIEN)
	      {
		if (ret < BOMBE_JOUEUR)
		  SDL_BlitSurface (elements[ret - RIEN + 1], NULL, ecran,
				   &pos);
		else
		  SDL_BlitSurface (bomb_players[(ret - BOMBE_JOUEUR)% NB_PLAYERS], NULL,
				   ecran, &pos);
	      }
	    else
	      SDL_BlitSurface (players[ret % NB_PLAYERS], NULL, ecran, &pos);
	  }

      sprintf (buffer, "Boum ! Tour %d / %d", tour_en_cours (), nb_tour);
      SDL_WM_SetCaption (buffer, NULL);
      SDL_Flip (ecran);

      pwet ();
    }
}


void
init_gui (void)
{
  SDL_Rect pos;
  SDL_Init (SDL_INIT_VIDEO);

  chdir ("gui");

  elements[JOUEUR] = IMG_Load ("imgs/perso.jpg");
  elements[MUR - RIEN + 1] = IMG_Load ("imgs/mur.jpg");
  elements[BRIQUE - RIEN + 1] = IMG_Load ("imgs/brique.jpg");
  elements[FLAMME - RIEN + 1] = IMG_Load ("imgs/flamme.jpg");
  elements[FLAMME_BONUS - RIEN + 1] = IMG_Load ("imgs/bonus_flamme.gif");
  elements[BOMBE_BONUS - RIEN + 1] = IMG_Load ("imgs/bonus_bombe.gif");
  elements[1] = IMG_Load ("imgs/rien.jpg");
  elements[BOMBE - RIEN + 1] = IMG_Load ("imgs/bombe.jpg");
  elements[BOMBE_JOUEUR - RIEN + 1] = IMG_Load ("imgs/perso-bombe.jpg");
  elements[MOTION_BONUS - RIEN + 1] = IMG_Load ("imgs/roller.png");

  players[0] = IMG_Load ("imgs/perso.jpg");
  players[1] = IMG_Load ("imgs/perso-rouge.jpg");
  players[2] = IMG_Load ("imgs/perso-bleu.jpg");
  players[3] = IMG_Load ("imgs/perso-noir.jpg");
  players[4] = IMG_Load ("imgs/perso-orange.jpg");
  players[5] = IMG_Load ("imgs/perso-vert.jpg");

  bomb_players[0] = IMG_Load ("imgs/perso-bombe.jpg");
  bomb_players[1] = IMG_Load ("imgs/perso-bombe-rouge.jpg");
  bomb_players[2] = IMG_Load ("imgs/perso-bombe-bleu.jpg");
  bomb_players[3] = IMG_Load ("imgs/perso-bombe-noir.jpg");
  bomb_players[4] = IMG_Load ("imgs/perso-bombe-orange.jpg");
  bomb_players[5] = IMG_Load ("imgs/perso-bombe-vert.jpg");
  
  
  longueur = largeur_map ();
  hauteur = hauteur_map ();

  ecran =
    SDL_SetVideoMode (longueur * TAILLE_ELEMENT, hauteur * TAILLE_ELEMENT, 32,
		      SDL_HWSURFACE);
  SDL_WM_SetCaption ("Boum !", NULL);
  nb_tour = nb_total_tours ();
  
}
#ifdef WIN32
void init_ptr_fonctions (ptr_fcts_t *p)
{
  ptr_fonctions = p;
}
#endif
