/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
[ProgCnet - Boum!]
Auteur: Thaeron
Projet: "serveur" Boum! (bomberman) du concours ProgCnet
Licence: GPL

Copyright (C) 2007 Thaeron

This program is free software; you can redistribute it and/or 
modify it under the terms of the GNU General Public License as 
published by the Free Software Foundation; either version 2 of the 
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but 
WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
General Public License for more details.

You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software 
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 
USA
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

#include "boum.h"

int
conv_car_file (char a)
{
  switch (a)
    {
    case '#':
      return MUR;
    case 'b':
      return BRIQUE;
    case ' ':
      return RIEN;
    case 'x':
      return RIEN;
    case 'f':
    	return FLAMME_BONUS;
    case 'm':
    	return MOTION_BONUS;
    case 'o':
    	return BOMBE_BONUS;
    default:
      return RIEN;
    };
  return RIEN;
}


void
clean_map (void)
{
  int i, j, ret;
  for (i = 0; i < struct_map->hauteur; i++)
    for (j = 0; j < struct_map->longueur; j++)
      {
	if (struct_map->map[i][j] == BONUS_FRAGILE)
	  struct_map->map[i][j] = FLAMME;
	else if (struct_map->map[i][j] == BRIQUE_FRAGILE)
	  {
	    ret = rand () % BONUS_CHANCE;

	    if (ret == 0)
	    {
	      struct_map->map[i][j] = BOMBE_BONUS;
	      struct_map->nb_bombe_bonus++;
	    }

	    else if (ret == 1)
	    {
	      struct_map->map[i][j] = FLAMME_BONUS;
	      struct_map->nb_flamme_bonus++;
	    }
	    
	    else if (ret == 2)
	    {
	      struct_map->map[i][j] = MOTION_BONUS;
	      struct_map->nb_motion_bonus++;
	    }

	    else
	      struct_map->map[i][j] = FLAMME;
	  }
      }
}

map_t *
load_map (char *f_map)
{
  FILE *f;
  map_t *m;
  char buffer[1024];
  int k, i;

  f = fopen (f_map, "r");
  if (!f)
    return (NULL);

  m = (map_t *) malloc (sizeof (map_t));
  fscanf (f, "%d,%d\n", &m->hauteur, &m->longueur);
  m->map = (int **) malloc (m->hauteur * sizeof (int *));

  m->date = 0;
  m->tour = NB_TOUR;
  m->nb_bombe = 0;
  
  m->nb_motion_bonus = 0;
  m->nb_bombe_bonus = 0;
  m->nb_flamme_bonus = 0;

  m->tab_pos = NULL;
  m->nb_pos = 0;  

  for (k = 0; k < m->hauteur; k++)
    {
      m->map[k] = (int *) malloc (m->longueur * sizeof (int));
      fgets (buffer, 1023, f);
      if (feof (f))
	{
	  fprintf (stderr, "Erreur : map incorrecte\n");
	  m->hauteur = k;
	  free_map (m);
	  m = NULL;
	  break;
	}

      for (i = 0; i < m->longueur; i++)
	{
	  m->map[k][i] = conv_car_file (buffer[i]);
	  if (m->map[k][i] == FLAMME_BONUS)
	  	m->nb_flamme_bonus++;
	  else if (m->map[k][i] == BOMBE_BONUS)
	  	m->nb_bombe_bonus++;
	  else if (m->map[k][i] == MOTION_BONUS)
	  	m->nb_motion_bonus++; 
	  
	  if (buffer[i] == 'x')
	    {
	      m->tab_pos = (player_pos_t **) realloc (m->tab_pos,(m->nb_pos + 1) * sizeof (player_pos_t *));
	      m->tab_pos[m->nb_pos] =
		(player_pos_t *) malloc (sizeof (player_pos_t));
	      m->tab_pos[m->nb_pos]->x = k;
	      m->tab_pos[m->nb_pos]->y = i;
	      m->tab_pos[m->nb_pos]->use = 0;
	      m->nb_pos++;
	    }
	}
    }
  
  fclose (f);
  return (m);
}

void
free_map (map_t * p)
{
  int a;
  for (a = 0; a < p->hauteur; a++)
    free (p->map[a]);
  free (p->map);
  free (p);
}

void
free_map_pos (map_t * p)
{
  int a;
  for (a = 0; a < p->nb_pos; a++)
    free (p->tab_pos[a]);
  free (p->tab_pos);
}
