/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
[ProgCnet - Boum!]
Auteur: Thaeron
Projet: "serveur" Boum! (bomberman) du concours ProgCnet
Licence: GPL

Copyright (C) 2007 Thaeron

This program is free software; you can redistribute it and/or 
modify it under the terms of the GNU General Public License as 
published by the Free Software Foundation; either version 2 of the 
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but 
WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
General Public License for more details.

You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software 
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 
USA
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

#include "boum.h"
#define NODE_VAL_MAX 0x7FFFFFFF

typedef struct _node_t node_t;
struct _node_t
{
  int x;
  int y;
  int poids;
};

int **
pathfinding_conv_map (void)
{
  int i, j, val;
  int **pm;

  pm = (int **) malloc (sizeof (int *) * struct_map->hauteur);
  for (i = 0; i < struct_map->hauteur; i++)
    pm[i] = (int *) malloc (sizeof (int) * struct_map->longueur);

  for (i = 0; i < struct_map->hauteur; i++)
    for (j = 0; j < struct_map->longueur; j++)
      {
      val = struct_map->map[i][j];
	if (val == RIEN ||val == FLAMME_BONUS || val == MOTION_BONUS || val == BOMBE_BONUS)
	  pm[i][j] = NODE_VAL_MAX;
	else
	  pm[i][j] = -1;
      }

  return (pm);
}

inline node_t **
add_node (int **n_map, node_t **node_tab, int *nb_node, int x, int y, int p)
{
  node_tab =
    (node_t **) realloc (node_tab, (*nb_node + 1) * sizeof (node_t *));
  node_tab[*nb_node] = (node_t *) malloc (sizeof (node_t));
  node_tab[*nb_node]->x = x;
  node_tab[*nb_node]->y = y;
  node_tab[*nb_node]->poids = p;
  n_map[x][y] = p;

/*   printf ("ajout du noeud [%d] (%d %d) : %d\n", nb_node, x, y, p); */
  (*nb_node)++;
  return (node_tab);
}


void
pathfinding_back (int **n_map, int xd, int yd, int xf, int yf)
{
  int in;
  node_t **node_tab = NULL;
  int nb_node = 0;

  node_tab = add_node (n_map, node_tab, &nb_node, xd, yd, 0);

  for (in = 0; in < nb_node; in++)
    {
      if (node_tab[in]->poids + 1 <= n_map[xf][yf])
	{
	  if (node_tab[in]->poids + 1 < n_map[node_tab[in]->x - 1][node_tab[in]->y])
	    node_tab = add_node (n_map, node_tab, &nb_node, node_tab[in]->x - 1, node_tab[in]->y, node_tab[in]->poids + 1);

	  if (node_tab[in]->poids + 1 < n_map[node_tab[in]->x + 1][node_tab[in]->y])
	    node_tab = add_node (n_map, node_tab, &nb_node, node_tab[in]->x + 1, node_tab[in]->y, node_tab[in]->poids + 1);

	  if (node_tab[in]->poids + 1 < n_map[node_tab[in]->x][node_tab[in]->y + 1])
	    node_tab = add_node (n_map, node_tab, &nb_node, node_tab[in]->x, node_tab[in]->y + 1, node_tab[in]->poids + 1);

	  if (node_tab[in]->poids + 1 < n_map[node_tab[in]->x][node_tab[in]->y - 1])
	    node_tab = add_node (n_map, node_tab, &nb_node, node_tab[in]->x, node_tab[in]->y - 1, node_tab[in]->poids + 1);

	}
      free (node_tab[in]);
    }
  free (node_tab);

  /*if (n_map[xf][yf] == NODE_VAL_MAX)
      puts ("pas de chemin");
  
    else printf ("poids de l'arrive : %d\n", n_map[xf][yf]);*/

/* {
 printf ("poids de l'arrive : %d\n", n_map[xf][yf]);

  while (n_map[xf][yf])
    {
      map[xf][yf] = '+';
      if (n_map[xf - 1][yf] == n_map[xf][yf] - 1)
	xf--;
      else if (n_map[xf + 1][yf] == n_map[xf][yf] - 1)
	xf++;
      else if (n_map[xf][yf + 1] == n_map[xf][yf] - 1)
	yf++;
      else if (n_map[xf][yf - 1] == n_map[xf][yf] - 1)
	yf--;
    }

  print_map (map, hauteur, largeur);
  }
  */
}


int
boum_pathfinding (int xf, int yf)
{
  int xd, yd, p_max;
  int **n_map, in, ret;

  n_map = pathfinding_conv_map ();
  
  xd = tab_players[struct_map->current_player]->x;
  yd = tab_players[struct_map->current_player]->y;
  pathfinding_back (n_map, xd, yd, xf, yf);

  ret = n_map[xf][yf];
  if (ret != NODE_VAL_MAX)
  {
  p_max = tab_players[struct_map->current_player]->mvt_dispo;
  
  while (n_map[xf][yf] > p_max)
    {
      if (n_map[xf - 1][yf] == n_map[xf][yf] - 1)
	xf--;
      else if (n_map[xf + 1][yf] == n_map[xf][yf] - 1)
	xf++;
      else if (n_map[xf][yf + 1] == n_map[xf][yf] - 1)
	yf++;
      else if (n_map[xf][yf - 1] == n_map[xf][yf] - 1)
	yf--;
    }

    xd = xf;
    yd = yf;
    
    while (n_map[xd][yd])
    {
      mv_on_map_back (xd, yd);
      if (n_map[xd - 1][yd] == n_map[xd][yd] - 1)
	xd--;
      else if (n_map[xd + 1][yd] == n_map[xd][yd] - 1)
	xd++;
      else if (n_map[xd][yd + 1] == n_map[xd][yd] - 1)
	yd++;
      else if (n_map[xd][yd - 1] == n_map[xd][yd] - 1)
	yd--;
    }

   if (struct_map->map[tab_players[struct_map->current_player]->x][tab_players[struct_map->current_player]->y] >= BOMBE_JOUEUR)
	struct_map->map[tab_players[struct_map->current_player]->x][tab_players[struct_map->current_player]->y] = BOMBE;
   else
        struct_map->map[tab_players[struct_map->current_player]->x][tab_players[struct_map->current_player]->y] = RIEN;

  tab_players[struct_map->current_player]->x = xf;
  tab_players[struct_map->current_player]->y = yf;

  struct_map->map[xf][yf] = JOUEUR + struct_map->current_player;

  tab_players[struct_map->current_player]->mvt_dispo -= n_map[xf][yf];
  p_max = n_map[xf][yf];
  }
  
  for (in = 0; in < struct_map->hauteur; in++)
  	free (n_map[in]);
  free (n_map);
  
  if (ret == NODE_VAL_MAX)
  	return (PAS_DE_CHEMIN);
  return (p_max);  
}


int
boum_distance_back (int xd, int yd, int xf, int yf)
{
  int **n_map;
  int ret, in;
  
  n_map = pathfinding_conv_map ();
  pathfinding_back (n_map, xd, yd, xf, yf);

  ret = n_map[xf][yf];

  for (in = 0; in < struct_map->hauteur; in++)
  	free (n_map[in]);
  free (n_map);
  
  if (ret == NODE_VAL_MAX)
  	return (PAS_DE_CHEMIN);
  
  return (ret);
}
