/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
[ProgCnet - Boum!]
Auteur: Thaeron
Projet: "serveur" Boum! (bomberman) du concours ProgCnet
Licence: GPL

Copyright (C) 2007 Thaeron

This program is free software; you can redistribute it and/or 
modify it under the terms of the GNU General Public License as 
published by the Free Software Foundation; either version 2 of the 
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but 
WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
General Public License for more details.

You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software 
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 
USA
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

#include "boum.h"

char
conv_car_map (int a)
{
  switch (a)
    {
    case RIEN:
      return ' ';
    case BRIQUE:
      return 'b';
    case MUR:
      return '#';
    case FLAMME:
      return '*';
    case BOMBE:
      return 'o';
    case FLAMME_BONUS:
      return 'f';
    case BOMBE_BONUS:
      return 'k';
    case MOTION_BONUS:
      return 'm';  
    default:
      break;
    }
  if (a >= JOUEUR && a < RIEN)
     return (a - JOUEUR + '0');
  
  if (a >= BOMBE_JOUEUR)
    return ('');
  return (' ');
}


void
print_map (int **m, int hauteur, int largeur)
{
  int a, b;
  for (a = 0; a < hauteur; a++)
    {
      for (b = 0; b < largeur; b++)
	printf ("%c", conv_car_map (m[a][b]));
      printf ("\n");
    }
}

void player_expulse (int id)
{
 tab_players[id]->status = MORT;
 struct_map->nb_joueur_lice--;
 if (struct_map->map[tab_players[id]->x][tab_players[id]->y] >= BOMBE_JOUEUR)
    struct_map->map[tab_players[id]->x][tab_players[id]->y] = BOMBE;
 else
    struct_map->map[tab_players[id]->x][tab_players[id]->y] = RIEN;
}

void mv_on_map_back (int tx, int ty)
{
  int val, val2;
      
  val = struct_map->map[tx][ty];
  val2 = struct_map->map[tab_players[struct_map->current_player]->x][tab_players[struct_map->current_player]->y];
      
  if (val2 >= BOMBE_JOUEUR)
     struct_map->map[tab_players[struct_map->current_player]->x][tab_players[struct_map->current_player]->y] = BOMBE;

  else
     struct_map->map[tab_players[struct_map->current_player]->x][tab_players[struct_map->current_player]->y] = RIEN;


  tab_players[struct_map->current_player]->y = ty;
  tab_players[struct_map->current_player]->x = tx;

  if (val == FLAMME_BONUS)
  {
     struct_map->nb_flamme_bonus--;
     tab_players[struct_map->current_player]->puissance += PUISSANCE_SUPP;
  }
  
  else if (val == BOMBE_BONUS)
  {
    struct_map->nb_bombe_bonus--;
    tab_players[struct_map->current_player]->bombe_tot++;
    tab_players[struct_map->current_player]->bombe_dispo++;
  }

  else if (val == MOTION_BONUS)
  {
    struct_map->nb_motion_bonus--;
    tab_players[struct_map->current_player]->mvt_tot++;
    tab_players[struct_map->current_player]->mvt_dispo++;
  }

  struct_map->map[tx][ty] = JOUEUR + struct_map->current_player;
}

int
back_aller (int tx, int ty)
{
  int val;
  
  if (struct_map->init)
  	return (PHASE_INIT);
  
  if (!tab_players[struct_map->current_player]->mvt_dispo)
  	return (PLUS_DE_MOUVEMENT);
	
  if (tab_players[struct_map->current_player]->status == MORT)
  	return (JOUEUR_MORT);
  
  val = struct_map->map[tx][ty];
  
  if (val == RIEN || val == FLAMME_BONUS || val == BOMBE_BONUS || val == MOTION_BONUS)
    {
      tab_players[struct_map->current_player]->mvt_dispo--;
      mv_on_map_back (tx, ty);
      return (NP);
    }

  else if (val == FLAMME)
	{
	  tab_players[struct_map->current_player]->status = MORT;
	  struct_map->nb_joueur_lice--;
	  struct_map->map[tx][ty] = FLAMME;
	  return (JOUEUR_MORT);
	}      
  
  return (ERREUR_TERRAIN);
}

